#pragma once
/*****************************************************************//**
 * \file   EchoDataFormat.h
 * \brief  洢еĸƷݸʽҪزݸʽݿ
 * 
 * \author 30453
 * \date   October 2024
 *********************************************************************/


#include "BaseConstVariable.h"

#include <complex>
#include <iostream>
#include <Eigen/Core>
#include <Eigen/Dense>
#include <omp.h>
#include <memory>
#include <vector>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <QString>


#include "BaseTool.h"
#include <iostream>
#include <fstream>
#include <complex>
#include <gdal.h>
#include <gdal_priv.h>
#include <gdalwarper.h>
#include <string>
#include <memory>
#include <QString>
#include <cpl_conv.h> // for CPLMalloc()

//========================================================================
// زʽ
// file type:
// PRFCOUNT
// PRFPOINT
// nearRange
// farRange
// PRF1,time,Px,Py,Pz,Vx,Vy,Vz
// PRF2,time,Px,Py,Pz,Vx,Vy,Vz
// ------------------  ļ    --------------------------------------
// PRF1,time,Px,Py,Pz,Vx,Vy,Vz,PRFPOINT,RealData,imagData
// PRF2,time,Px,Py,Pz,Vx,Vy,Vz,PRFPOINT,RealData,imagData
// --------------------------------------------------------------
// עBp˳ֻǹעλãĬϰĽ˳֯
//========================================================================

// õĻزļʽ

/// <summary>
/// ز--
/// </summary>
struct PluseData {
	long id;  // PRF id
	double time;// ʱ
	double Px; // 
	double Py;
	double Pz;
	double Vx; // ٶ
	double Vy;
	double Vz;
	long plusePoints; // 
	std::shared_ptr<std::complex<double>> echoData; // ز
};

long getPluseDataSize(PluseData& pluseData);
ErrorCode getPluseDataFromBuffer(char* buffer, PluseData& data);
std::shared_ptr<PluseData> CreatePluseDataArr(long pluseCount);
std::shared_ptr<std::complex<double>> CreateEchoData(long plusePoints);



/// <summary>
/// ̬
/// </summary>
struct PluseAntPos {
	long id;  // PRF id
	double time;// ʱ
	double Px; // 
	double Py;
	double Pz;
	double Vx; // ٶ
	double Vy;
	double Vz;
};
std::shared_ptr<PluseAntPos> CreatePluseAntPosArr(long pluseCount);


// L0
class EchoL0Dataset {

public:
	EchoL0Dataset();
	~EchoL0Dataset();


public:
	ErrorCode OpenOrNew(QString folder, QString filename,long PluseCount,long PlusePoints);
	ErrorCode Open(QString xmlfilepath);
	ErrorCode Open(QString folder, QString filename);
	QString getxmlName();
	QString getGPSPointFilename();
	QString getEchoDataFilename();

private: // Ʒ
	QString folder;
	QString filename;
	QString xmlname;
	QString GPSPointFilename;
	QString echoDataFilename;
	//
	QString xmlFilePath;
	QString GPSPointFilePath;
	QString echoDataFilePath;



public: // ļ
	// Getter  Setter 
	long getPluseCount() ;
	void setPluseCount(long pulseCount);

	long getPlusePoints() ;
	void setPlusePoints(long pulsePoints);

	double getNearRange() ;
	void setNearRange(double nearRange);

	double getFarRange() ;
	void setFarRange(double farRange);

	double getCenterFreq() ;
	void setCenterFreq(double freq);

	double getFs() ;
	void setFs(double samplingFreq);

	QString getSimulationTaskName() ;
	void setSimulationTaskName(const QString& taskName);

	double getCenterAngle();
	void setCenterAngle(double angle);

	QString getLookSide();
	void setLookSide(QString lookside);

	SatelliteAntPos getSatelliteAntPos(long plusePRFID);
	// ӡϢĳԱ
	void printInfo() ;	

private: // ز
	long PluseCount;
	long PlusePoints;
	double NearRange;
	double FarRange;
	double centerFreq; // Ƶ
	double Fs; // ЧƵ
	QString simulationTaskName;

	double CenterAngle;
	QString LookSide;

public: 	// д XML ĺ
	void saveToXml();
	ErrorCode loadFromXml();

public:
	// ȡļ
	std::shared_ptr<double> getAntPos();
	std::shared_ptr<std::complex<double>> getEchoArr(long startPRF, long PRFLen);
	std::shared_ptr<std::complex<double>> getEchoArr();
	//ļ
	ErrorCode saveAntPos(std::shared_ptr<double> ptr); // עΣգдǰǷȷ
	ErrorCode saveEchoArr(std::shared_ptr<std::complex<double>> echoPtr, long startPRF, long PRFLen);





};




